# coding: utf-8

"""
    Yagna Market API

     ## Yagna Market The Yagna Market is a core component of the Yagna Network, which enables computational Offers and Demands circulation. The Market is open for all entities willing to buy computations (Demands) or monetize computational resources (Offers). ## Yagna Market API The Yagna Market API is the entry to the Yagna Market through which Requestors and Providers can publish their Demands and Offers respectively, find matching counterparty, conduct negotiations and make an agreement.  This version of Market API conforms with capability level 1 of the <a href=\"https://docs.google.com/document/d/1Zny_vfgWV-hcsKS7P-Kdr3Fb0dwfl-6T_cYKVQ9mkNg\"> Market API specification</a>.  Market API contains two roles: Requestors and Providers which are symmetrical most of the time (excluding agreement phase).   # noqa: E501

    The version of the OpenAPI document: 1.6.1
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401


from ya_market.configuration import Configuration


class OfferAllOf(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'offer_id': 'str',
        'provider_id': 'str',
        'timestamp': 'datetime'
    }

    attribute_map = {
        'offer_id': 'offerId',
        'provider_id': 'providerId',
        'timestamp': 'timestamp'
    }

    def __init__(self, offer_id=None, provider_id=None, timestamp=None, local_vars_configuration=None):  # noqa: E501
        """OfferAllOf - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._offer_id = None
        self._provider_id = None
        self._timestamp = None
        self.discriminator = None

        self.offer_id = offer_id
        self.provider_id = provider_id
        self.timestamp = timestamp

    @property
    def offer_id(self):
        """Gets the offer_id of this OfferAllOf.  # noqa: E501


        :return: The offer_id of this OfferAllOf.  # noqa: E501
        :rtype: str
        """
        return self._offer_id

    @offer_id.setter
    def offer_id(self, offer_id):
        """Sets the offer_id of this OfferAllOf.


        :param offer_id: The offer_id of this OfferAllOf.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and offer_id is None:  # noqa: E501
            raise ValueError("Invalid value for `offer_id`, must not be `None`")  # noqa: E501

        self._offer_id = offer_id

    @property
    def provider_id(self):
        """Gets the provider_id of this OfferAllOf.  # noqa: E501


        :return: The provider_id of this OfferAllOf.  # noqa: E501
        :rtype: str
        """
        return self._provider_id

    @provider_id.setter
    def provider_id(self, provider_id):
        """Sets the provider_id of this OfferAllOf.


        :param provider_id: The provider_id of this OfferAllOf.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and provider_id is None:  # noqa: E501
            raise ValueError("Invalid value for `provider_id`, must not be `None`")  # noqa: E501

        self._provider_id = provider_id

    @property
    def timestamp(self):
        """Gets the timestamp of this OfferAllOf.  # noqa: E501


        :return: The timestamp of this OfferAllOf.  # noqa: E501
        :rtype: datetime
        """
        return self._timestamp

    @timestamp.setter
    def timestamp(self, timestamp):
        """Sets the timestamp of this OfferAllOf.


        :param timestamp: The timestamp of this OfferAllOf.  # noqa: E501
        :type: datetime
        """
        if self.local_vars_configuration.client_side_validation and timestamp is None:  # noqa: E501
            raise ValueError("Invalid value for `timestamp`, must not be `None`")  # noqa: E501

        self._timestamp = timestamp

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in self.openapi_types.items():
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(
                    map(lambda x: x.to_dict() if hasattr(x, "to_dict") else x, value)
                )
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(
                    map(
                        lambda item: (item[0], item[1].to_dict())
                        if hasattr(item[1], "to_dict")
                        else item,
                        value.items(),
                    )
                )
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, OfferAllOf):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, OfferAllOf):
            return True

        return self.to_dict() != other.to_dict()
